Index: uspace/srv/hid/console/console.c
===================================================================
--- uspace/srv/hid/console/console.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/console/console.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -63,5 +63,5 @@
 typedef struct {
 	atomic_flag refcnt;      /**< Connection reference count */
-	prodcons_t input_pc;  /**< Incoming console events */
+	prodcons_t input_pc;  /**< Incoming keyboard events */
 
 	/**
@@ -99,14 +99,4 @@
 static sysarg_t cols;
 static sysarg_t rows;
-
-/** Mouse pointer X coordinate */
-static int pointer_x;
-/** Mouse pointer Y coordinate */
-static int pointer_y;
-/** Character under mouse cursor */
-static charfield_t pointer_bg;
-
-static int mouse_scale_x = 4;
-static int mouse_scale_y = 8;
 
 /** Array of data for virtual consoles */
@@ -176,7 +166,4 @@
 };
 
-static void pointer_draw(void);
-static void pointer_undraw(void);
-
 static console_t *srv_to_console(con_srv_t *srv)
 {
@@ -244,5 +231,4 @@
 
 	fibril_mutex_lock(&switch_mtx);
-	pointer_undraw();
 
 	if (cons == active_console) {
@@ -253,85 +239,7 @@
 	active_console = cons;
 
-	pointer_draw();
 	fibril_mutex_unlock(&switch_mtx);
 
 	cons_damage(cons);
-}
-
-/** Draw mouse pointer. */
-static void pointer_draw(void)
-{
-	charfield_t *ch;
-	int col, row;
-
-	/* Downscale coordinates to text resolution */
-	col = pointer_x / mouse_scale_x;
-	row = pointer_y / mouse_scale_y;
-
-	/* Make sure they are in range */
-	if (col < 0 || row < 0 || col >= (int)cols || row >= (int)rows)
-		return;
-
-	ch = chargrid_charfield_at(active_console->frontbuf, col, row);
-
-	/*
-	 * Store background attributes for undrawing the pointer.
-	 * This is necessary as styles cannot be inverted with
-	 * round trip (unlike RGB or INDEX)
-	 */
-	pointer_bg = *ch;
-
-	/* In general the color should be a one's complement of the background */
-	if (ch->attrs.type == CHAR_ATTR_INDEX) {
-		ch->attrs.val.index.bgcolor ^= 0xf;
-		ch->attrs.val.index.fgcolor ^= 0xf;
-	} else if (ch->attrs.type == CHAR_ATTR_RGB) {
-		ch->attrs.val.rgb.fgcolor ^= 0xffffff;
-		ch->attrs.val.rgb.bgcolor ^= 0xffffff;
-	} else if (ch->attrs.type == CHAR_ATTR_STYLE) {
-		/* Don't have a proper inverse for each style */
-		if (ch->attrs.val.style == STYLE_INVERTED)
-			ch->attrs.val.style = STYLE_NORMAL;
-		else
-			ch->attrs.val.style = STYLE_INVERTED;
-	}
-
-	/* Make sure the cell gets updated */
-	ch->flags |= CHAR_FLAG_DIRTY;
-}
-
-/** Undraw mouse pointer. */
-static void pointer_undraw(void)
-{
-	charfield_t *ch;
-	int col, row;
-
-	col = pointer_x / mouse_scale_x;
-	row = pointer_y / mouse_scale_y;
-	if (col < 0 || row < 0 || col >= (int)cols || row >= (int)rows)
-		return;
-
-	ch = chargrid_charfield_at(active_console->frontbuf, col, row);
-	*ch = pointer_bg;
-	ch->flags |= CHAR_FLAG_DIRTY;
-}
-
-/** Queue console event.
- *
- * @param cons Console
- * @param ev Console event
- */
-static void console_queue_cons_event(console_t *cons, cons_event_t *ev)
-{
-	/* Got key press/release event */
-	cons_event_t *event =
-	    (cons_event_t *) malloc(sizeof(cons_event_t));
-	if (event == NULL)
-		return;
-
-	*event = *ev;
-	link_initialize(&event->link);
-
-	prodcons_produce(&cons->input_pc, &event->link);
 }
 
@@ -356,6 +264,4 @@
     keymod_t mods, char32_t c)
 {
-	cons_event_t event;
-
 	if ((key >= KC_F1) && (key <= KC_F1 + CONSOLE_COUNT) &&
 	    ((mods & KM_CTRL) == 0)) {
@@ -363,57 +269,25 @@
 	} else {
 		/* Got key press/release event */
-		event.type = CEV_KEY;
-
-		event.ev.key.type = type;
-		event.ev.key.key = key;
-		event.ev.key.mods = mods;
-		event.ev.key.c = c;
-
-		console_queue_cons_event(active_console, &event);
-	}
-
-	return EOK;
-}
-
-/** Update pointer position.
- *
- * @param new_x New X coordinate (in pixels)
- * @param new_y New Y coordinate (in pixels)
- */
-static void pointer_update(int new_x, int new_y)
-{
-	bool upd_pointer;
-
-	/* Make sure coordinates are in range */
-
-	if (new_x < 0)
-		new_x = 0;
-	if (new_x >= (int)cols * mouse_scale_x)
-		new_x = cols * mouse_scale_x - 1;
-	if (new_y < 0)
-		new_y = 0;
-	if (new_y >= (int)rows * mouse_scale_y)
-		new_y = rows * mouse_scale_y - 1;
-
-	/* Determine if pointer moved to a different character cell */
-	upd_pointer = (new_x / mouse_scale_x != pointer_x / mouse_scale_x) ||
-	    (new_y / mouse_scale_y != pointer_y / mouse_scale_y);
-
-	if (upd_pointer)
-		pointer_undraw();
-
-	/* Store new pointer position */
-	pointer_x = new_x;
-	pointer_y = new_y;
-
-	if (upd_pointer) {
-		pointer_draw();
-		cons_update(active_console);
-	}
+		kbd_event_t *event =
+		    (kbd_event_t *) malloc(sizeof(kbd_event_t));
+		if (event == NULL) {
+			return ENOMEM;
+		}
+
+		link_initialize(&event->link);
+		event->type = type;
+		event->key = key;
+		event->mods = mods;
+		event->c = c;
+
+		prodcons_produce(&active_console->input_pc,
+		    &event->link);
+	}
+
+	return EOK;
 }
 
 static errno_t input_ev_move(input_t *input, int dx, int dy)
 {
-	pointer_update(pointer_x + dx, pointer_y + dy);
 	return EOK;
 }
@@ -422,5 +296,4 @@
     unsigned max_x, unsigned max_y)
 {
-	pointer_update(mouse_scale_x * cols * x / max_x, mouse_scale_y * rows * y / max_y);
 	return EOK;
 }
@@ -428,13 +301,4 @@
 static errno_t input_ev_button(input_t *input, int bnum, int bpress)
 {
-	cons_event_t event;
-
-	event.type = CEV_POS;
-	event.ev.pos.type = bpress ? POS_PRESS : POS_RELEASE;
-	event.ev.pos.btn_num = bnum;
-	event.ev.pos.hpos = pointer_x / mouse_scale_x;
-	event.ev.pos.vpos = pointer_y / mouse_scale_y;
-
-	console_queue_cons_event(active_console, &event);
 	return EOK;
 }
@@ -446,5 +310,4 @@
 
 	fibril_mutex_lock(&cons->mtx);
-	pointer_undraw();
 
 	switch (ch) {
@@ -464,5 +327,4 @@
 	}
 
-	pointer_draw();
 	fibril_mutex_unlock(&cons->mtx);
 
@@ -474,7 +336,5 @@
 {
 	fibril_mutex_lock(&cons->mtx);
-	pointer_undraw();
 	chargrid_set_cursor_visibility(cons->frontbuf, visible);
-	pointer_draw();
 	fibril_mutex_unlock(&cons->mtx);
 
@@ -519,11 +379,9 @@
 		if (pos < size) {
 			link_t *link = prodcons_consume(&cons->input_pc);
-			cons_event_t *event = list_get_instance(link,
-			    cons_event_t, link);
+			kbd_event_t *event = list_get_instance(link, kbd_event_t, link);
 
 			/* Accept key presses of printable chars only. */
-			if (event->type == CEV_KEY && event->ev.key.type == KEY_PRESS &&
-			    (event->ev.key.c != 0)) {
-				char32_t tmp[2] = { event->ev.key.c, 0 };
+			if ((event->type == KEY_PRESS) && (event->c != 0)) {
+				char32_t tmp[2] = { event->c, 0 };
 				wstr_to_str(cons->char_remains, UTF8_CHAR_BUFFER_SIZE, tmp);
 				cons->char_remains_len = str_size(cons->char_remains);
@@ -562,7 +420,5 @@
 
 	fibril_mutex_lock(&cons->mtx);
-	pointer_undraw();
 	chargrid_clear(cons->frontbuf);
-	pointer_draw();
 	fibril_mutex_unlock(&cons->mtx);
 
@@ -575,7 +431,5 @@
 
 	fibril_mutex_lock(&cons->mtx);
-	pointer_undraw();
 	chargrid_set_cursor(cons->frontbuf, col, row);
-	pointer_draw();
 	fibril_mutex_unlock(&cons->mtx);
 
@@ -657,8 +511,10 @@
 	console_t *cons = srv_to_console(srv);
 	link_t *link = prodcons_consume(&cons->input_pc);
-	cons_event_t *cevent = list_get_instance(link, cons_event_t, link);
-
-	*event = *cevent;
-	free(cevent);
+	kbd_event_t *kevent = list_get_instance(link, kbd_event_t, link);
+
+	event->type = CEV_KEY;
+	event->ev.key = *kevent;
+
+	free(kevent);
 	return EOK;
 }
@@ -765,6 +621,4 @@
 	/* Update front buffer from user buffer */
 
-	pointer_undraw();
-
 	for (row = r0; row < r1; row++) {
 		for (col = c0; col < c1; col++) {
@@ -774,5 +628,4 @@
 	}
 
-	pointer_draw();
 	fibril_mutex_unlock(&cons->mtx);
 
Index: uspace/srv/hid/display/display.c
===================================================================
--- uspace/srv/hid/display/display.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/display/display.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2019 Jiri Svoboda
  * All rights reserved.
  *
@@ -53,9 +53,4 @@
 static void ds_display_update_cb(void *);
 
-static mem_gc_cb_t ds_display_mem_gc_cb = {
-	.invalidate = ds_display_invalidate_cb,
-	.update = ds_display_update_cb
-};
-
 /** Create display.
  *
@@ -464,6 +459,7 @@
 		goto error;
 
-	rc = mem_gc_create(&disp->rect, &alloc, &ds_display_mem_gc_cb,
-	    (void *) disp, &disp->bbgc);
+	rc = mem_gc_create(&disp->rect, &alloc,
+	    ds_display_invalidate_cb, ds_display_update_cb, (void *) disp,
+	    &disp->bbgc);
 	if (rc != EOK)
 		goto error;
Index: uspace/srv/hid/display/window.c
===================================================================
--- uspace/srv/hid/display/window.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/display/window.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -53,9 +53,4 @@
 static void ds_window_get_preview_rect(ds_window_t *, gfx_rect_t *);
 
-static mem_gc_cb_t ds_window_mem_gc_cb = {
-	.invalidate = ds_window_invalidate_cb,
-	.update = ds_window_update_cb
-};
-
 /** Create window.
  *
@@ -113,6 +108,6 @@
 	}
 
-	rc = mem_gc_create(&params->rect, &alloc, &ds_window_mem_gc_cb,
-	    (void *)wnd, &wnd->mgc);
+	rc = mem_gc_create(&params->rect, &alloc, ds_window_invalidate_cb,
+	    ds_window_update_cb, (void *)wnd, &wnd->mgc);
 	if (rc != EOK)
 		goto error;
Index: uspace/srv/hid/input/input.c
===================================================================
--- uspace/srv/hid/input/input.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/input/input.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -641,7 +641,4 @@
 	kbd_add_dev(&chardev_port, &stty_ctl);
 #endif
-#if defined(UARCH_arm64) && defined(MACHINE_hikey960)
-	kbd_add_dev(&chardev_port, &stty_ctl);
-#endif
 	/* Silence warning on abs32le about kbd_add_dev() being unused */
 	(void) kbd_add_dev;
Index: uspace/srv/hid/output/meson.build
===================================================================
--- uspace/srv/hid/output/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/output/meson.build	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -28,5 +28,5 @@
 #
 
-deps = [ 'codepage', 'drv', 'fbfont', 'pixconv', 'ddev' ]
+deps = [ 'drv', 'fbfont', 'pixconv', 'ddev' ]
 src = files(
 	'ctl/serial.c',
Index: uspace/srv/hid/output/port/chardev.c
===================================================================
--- uspace/srv/hid/output/port/chardev.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/output/port/chardev.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -78,25 +78,11 @@
 }
 
-static void chardev_putchar(char ch)
+static void chardev_putuchar(char32_t ch)
 {
 	if (chardev_bused == chardev_buf_size)
 		chardev_flush();
+	if (!ascii_check(ch))
+		ch = '?';
 	chardev_buf[chardev_bused++] = (uint8_t) ch;
-}
-
-static void chardev_putuchar(char32_t ch)
-{
-	char buf[STR_BOUNDS(1)];
-	size_t off;
-	size_t i;
-	errno_t rc;
-
-	off = 0;
-	rc = chr_encode(ch, buf, &off, sizeof(buf));
-	if (rc != EOK)
-		return;
-
-	for (i = 0; i < off; i++)
-		chardev_putchar(buf[i]);
 }
 
@@ -232,6 +218,4 @@
 #elif defined(UARCH_arm64) && defined(MACHINE_virt)
 		/* OK */
-#elif defined(UARCH_arm64) && defined(MACHINE_hikey960)
-		/* OK */
 #else
 		return EOK;
Index: uspace/srv/hid/output/port/ega.c
===================================================================
--- uspace/srv/hid/output/port/ega.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/output/port/ega.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,3 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2011 Martin Decky
  * All rights reserved.
@@ -32,5 +31,4 @@
  */
 
-#include <codepage/cp437.h>
 #include <errno.h>
 #include <sysinfo.h>
@@ -108,8 +106,8 @@
 {
 	uint8_t glyph;
-	errno_t rc;
-
-	rc = cp437_encode(field->ch, &glyph);
-	if (rc != EOK)
+
+	if (ascii_check(field->ch))
+		glyph = field->ch;
+	else
 		glyph = '?';
 
Index: uspace/srv/hid/output/proto/vt100.c
===================================================================
--- uspace/srv/hid/output/proto/vt100.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/output/proto/vt100.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,3 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2011 Martin Decky
  * All rights reserved.
@@ -66,5 +65,5 @@
 static sgr_color_index_t color_map[] = {
 	[COLOR_BLACK]   = CI_BLACK,
-	[COLOR_BLUE]    = CI_BLUE,
+	[COLOR_BLUE]    = CI_RED,
 	[COLOR_GREEN]   = CI_GREEN,
 	[COLOR_CYAN]    = CI_CYAN,
Index: uspace/srv/net/dhcp/dhcp.c
===================================================================
--- uspace/srv/net/dhcp/dhcp.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/dhcp/dhcp.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2013 Jiri Svoboda
  * All rights reserved.
  *
@@ -42,5 +42,4 @@
 #include <fibril_synch.h>
 #include <inet/addr.h>
-#include <inet/eth_addr.h>
 #include <inet/dnsr.h>
 #include <inet/inetcfg.h>
@@ -158,9 +157,9 @@
 	hdr->op = op_bootrequest;
 	hdr->htype = 1; /* AHRD_ETHERNET */
-	hdr->hlen = ETH_ADDR_SIZE;
+	hdr->hlen = sizeof(addr48_t);
 	hdr->xid = host2uint32_t_be(42);
 	hdr->flags = flag_broadcast;
 
-	eth_addr_encode(&dlink->link_info.mac_addr, hdr->chaddr);
+	addr48(dlink->link_info.mac_addr, hdr->chaddr);
 	hdr->opt_magic = host2uint32_t_be(dhcp_opt_magic);
 
@@ -186,5 +185,5 @@
 	hdr->flags = flag_broadcast;
 	hdr->ciaddr = host2uint32_t_be(offer->oaddr.addr);
-	eth_addr_encode(&dlink->link_info.mac_addr, hdr->chaddr);
+	addr48(dlink->link_info.mac_addr, hdr->chaddr);
 	hdr->opt_magic = host2uint32_t_be(dhcp_opt_magic);
 
Index: uspace/srv/net/ethip/arp.c
===================================================================
--- uspace/srv/net/ethip/arp.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/ethip/arp.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -36,8 +36,7 @@
 
 #include <errno.h>
+#include <io/log.h>
 #include <inet/iplink_srv.h>
 #include <inet/addr.h>
-#include <inet/eth_addr.h>
-#include <io/log.h>
 #include <stdlib.h>
 #include "arp.h"
@@ -80,5 +79,5 @@
 
 	(void) atrans_add(packet.sender_proto_addr,
-	    &packet.sender_hw_addr);
+	    packet.sender_hw_addr);
 
 	if (packet.opcode == aop_request) {
@@ -86,7 +85,7 @@
 
 		reply.opcode = aop_reply;
-		reply.sender_hw_addr = nic->mac_addr;
+		addr48(nic->mac_addr, reply.sender_hw_addr);
 		reply.sender_proto_addr = laddr_v4;
-		reply.target_hw_addr = packet.sender_hw_addr;
+		addr48(packet.sender_hw_addr, reply.target_hw_addr);
 		reply.target_proto_addr = packet.sender_proto_addr;
 
@@ -96,9 +95,9 @@
 
 errno_t arp_translate(ethip_nic_t *nic, addr32_t src_addr, addr32_t ip_addr,
-    eth_addr_t *mac_addr)
+    addr48_t mac_addr)
 {
 	/* Broadcast address */
 	if (ip_addr == addr32_broadcast_all_hosts) {
-		*mac_addr = eth_addr_broadcast;
+		addr48(addr48_broadcast, mac_addr);
 		return EOK;
 	}
@@ -111,7 +110,7 @@
 
 	packet.opcode = aop_request;
-	packet.sender_hw_addr = nic->mac_addr;
+	addr48(nic->mac_addr, packet.sender_hw_addr);
 	packet.sender_proto_addr = src_addr;
-	packet.target_hw_addr = eth_addr_broadcast;
+	addr48(addr48_broadcast, packet.target_hw_addr);
 	packet.target_proto_addr = ip_addr;
 
@@ -139,6 +138,6 @@
 		return rc;
 
-	frame.dest = packet->target_hw_addr;
-	frame.src = packet->sender_hw_addr;
+	addr48(packet->target_hw_addr, frame.dest);
+	addr48(packet->sender_hw_addr, frame.src);
 	frame.etype_len = ETYPE_ARP;
 	frame.data = pdata;
Index: uspace/srv/net/ethip/arp.h
===================================================================
--- uspace/srv/net/ethip/arp.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/ethip/arp.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -38,11 +38,10 @@
 #define ARP_H_
 
+#include <inet/iplink_srv.h>
 #include <inet/addr.h>
-#include <inet/eth_addr.h>
-#include <inet/iplink_srv.h>
 #include "ethip.h"
 
 extern void arp_received(ethip_nic_t *, eth_frame_t *);
-extern errno_t arp_translate(ethip_nic_t *, addr32_t, addr32_t, eth_addr_t *);
+extern errno_t arp_translate(ethip_nic_t *, addr32_t, addr32_t, addr48_t);
 
 #endif
Index: uspace/srv/net/ethip/atrans.c
===================================================================
--- uspace/srv/net/ethip/atrans.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/ethip/atrans.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -38,5 +38,4 @@
 #include <errno.h>
 #include <fibril_synch.h>
-#include <inet/eth_addr.h>
 #include <inet/iplink_srv.h>
 #include <stdlib.h>
@@ -60,5 +59,5 @@
 }
 
-errno_t atrans_add(addr32_t ip_addr, eth_addr_t *mac_addr)
+errno_t atrans_add(addr32_t ip_addr, addr48_t mac_addr)
 {
 	ethip_atrans_t *atrans;
@@ -70,5 +69,5 @@
 
 	atrans->ip_addr = ip_addr;
-	atrans->mac_addr = *mac_addr;
+	addr48(mac_addr, atrans->mac_addr);
 
 	fibril_mutex_lock(&atrans_list_lock);
@@ -104,5 +103,5 @@
 }
 
-static errno_t atrans_lookup_locked(addr32_t ip_addr, eth_addr_t *mac_addr)
+static errno_t atrans_lookup_locked(addr32_t ip_addr, addr48_t mac_addr)
 {
 	ethip_atrans_t *atrans = atrans_find(ip_addr);
@@ -110,9 +109,9 @@
 		return ENOENT;
 
-	*mac_addr = atrans->mac_addr;
+	addr48(atrans->mac_addr, mac_addr);
 	return EOK;
 }
 
-errno_t atrans_lookup(addr32_t ip_addr, eth_addr_t *mac_addr)
+errno_t atrans_lookup(addr32_t ip_addr, addr48_t mac_addr)
 {
 	errno_t rc;
@@ -136,5 +135,5 @@
 
 errno_t atrans_lookup_timeout(addr32_t ip_addr, usec_t timeout,
-    eth_addr_t *mac_addr)
+    addr48_t mac_addr)
 {
 	fibril_timer_t *t;
Index: uspace/srv/net/ethip/atrans.h
===================================================================
--- uspace/srv/net/ethip/atrans.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/ethip/atrans.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -38,13 +38,12 @@
 #define ATRANS_H_
 
+#include <inet/iplink_srv.h>
 #include <inet/addr.h>
-#include <inet/eth_addr.h>
-#include <inet/iplink_srv.h>
 #include "ethip.h"
 
-extern errno_t atrans_add(addr32_t, eth_addr_t *);
+extern errno_t atrans_add(addr32_t, addr48_t);
 extern errno_t atrans_remove(addr32_t);
-extern errno_t atrans_lookup(addr32_t, eth_addr_t *);
-extern errno_t atrans_lookup_timeout(addr32_t, usec_t, eth_addr_t *);
+extern errno_t atrans_lookup(addr32_t, addr48_t);
+extern errno_t atrans_lookup_timeout(addr32_t, usec_t, addr48_t);
 
 #endif
Index: uspace/srv/net/ethip/ethip.c
===================================================================
--- uspace/srv/net/ethip/ethip.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/ethip/ethip.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -39,5 +39,4 @@
 #include <async.h>
 #include <errno.h>
-#include <inet/eth_addr.h>
 #include <inet/iplink_srv.h>
 #include <io/log.h>
@@ -59,6 +58,6 @@
 static errno_t ethip_send6(iplink_srv_t *srv, iplink_sdu6_t *sdu);
 static errno_t ethip_get_mtu(iplink_srv_t *srv, size_t *mtu);
-static errno_t ethip_get_mac48(iplink_srv_t *srv, eth_addr_t *mac);
-static errno_t ethip_set_mac48(iplink_srv_t *srv, eth_addr_t *mac);
+static errno_t ethip_get_mac48(iplink_srv_t *srv, addr48_t *mac);
+static errno_t ethip_set_mac48(iplink_srv_t *srv, addr48_t *mac);
 static errno_t ethip_addr_add(iplink_srv_t *srv, inet_addr_t *addr);
 static errno_t ethip_addr_remove(iplink_srv_t *srv, inet_addr_t *addr);
@@ -178,5 +177,5 @@
 	eth_frame_t frame;
 
-	errno_t rc = arp_translate(nic, sdu->src, sdu->dest, &frame.dest);
+	errno_t rc = arp_translate(nic, sdu->src, sdu->dest, frame.dest);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_WARN, "Failed to look up IPv4 address 0x%"
@@ -185,5 +184,5 @@
 	}
 
-	frame.src = nic->mac_addr;
+	addr48(nic->mac_addr, frame.src);
 	frame.etype_len = ETYPE_IP;
 	frame.data = sdu->data;
@@ -209,6 +208,6 @@
 	eth_frame_t frame;
 
-	frame.dest = sdu->dest;
-	frame.src = nic->mac_addr;
+	addr48(sdu->dest, frame.dest);
+	addr48(nic->mac_addr, frame.src);
 	frame.etype_len = ETYPE_IPV6;
 	frame.data = sdu->data;
@@ -277,20 +276,20 @@
 }
 
-static errno_t ethip_get_mac48(iplink_srv_t *srv, eth_addr_t *mac)
+static errno_t ethip_get_mac48(iplink_srv_t *srv, addr48_t *mac)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_get_mac48()");
 
 	ethip_nic_t *nic = (ethip_nic_t *) srv->arg;
-	*mac = nic->mac_addr;
-
-	return EOK;
-}
-
-static errno_t ethip_set_mac48(iplink_srv_t *srv, eth_addr_t *mac)
+	addr48(nic->mac_addr, *mac);
+
+	return EOK;
+}
+
+static errno_t ethip_set_mac48(iplink_srv_t *srv, addr48_t *mac)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_set_mac48()");
 
 	ethip_nic_t *nic = (ethip_nic_t *) srv->arg;
-	nic->mac_addr = *mac;
+	addr48(*mac, nic->mac_addr);
 
 	return EOK;
Index: uspace/srv/net/ethip/ethip.h
===================================================================
--- uspace/srv/net/ethip/ethip.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/ethip/ethip.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -40,7 +40,6 @@
 #include <adt/list.h>
 #include <async.h>
+#include <inet/iplink_srv.h>
 #include <inet/addr.h>
-#include <inet/eth_addr.h>
-#include <inet/iplink_srv.h>
 #include <loc.h>
 #include <stddef.h>
@@ -62,5 +61,5 @@
 
 	/** MAC address */
-	eth_addr_t mac_addr;
+	addr48_t mac_addr;
 
 	/**
@@ -74,7 +73,7 @@
 typedef struct {
 	/** Destination Address */
-	eth_addr_t dest;
+	addr48_t dest;
 	/** Source Address */
-	eth_addr_t src;
+	addr48_t src;
 	/** Ethertype or Length */
 	uint16_t etype_len;
@@ -101,9 +100,9 @@
 	arp_opcode_t opcode;
 	/** Sender hardware address */
-	eth_addr_t sender_hw_addr;
+	addr48_t sender_hw_addr;
 	/** Sender protocol address */
 	addr32_t sender_proto_addr;
 	/** Target hardware address */
-	eth_addr_t target_hw_addr;
+	addr48_t target_hw_addr;
 	/** Target protocol address */
 	addr32_t target_proto_addr;
@@ -114,5 +113,5 @@
 	link_t atrans_list;
 	addr32_t ip_addr;
-	eth_addr_t mac_addr;
+	addr48_t mac_addr;
 } ethip_atrans_t;
 
Index: uspace/srv/net/ethip/ethip_nic.c
===================================================================
--- uspace/srv/net/ethip/ethip_nic.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/ethip/ethip_nic.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -37,15 +37,14 @@
 #include <adt/list.h>
 #include <async.h>
+#include <stdbool.h>
 #include <errno.h>
+#include <str_error.h>
 #include <fibril_synch.h>
-#include <inet/eth_addr.h>
 #include <inet/iplink_srv.h>
 #include <io/log.h>
 #include <loc.h>
+#include <nic_iface.h>
+#include <stdlib.h>
 #include <mem.h>
-#include <nic_iface.h>
-#include <stdbool.h>
-#include <stdlib.h>
-#include <str_error.h>
 #include "ethip.h"
 #include "ethip_nic.h"
@@ -194,5 +193,5 @@
 	}
 
-	eth_addr_decode(nic_address.address, &nic->mac_addr);
+	addr48(nic_address.address, nic->mac_addr);
 
 	rc = nic_set_state(nic->sess, NIC_STATE_ACTIVE);
@@ -400,6 +399,6 @@
 		assert(i < count);
 
-		eth_addr_t mac;
-		eth_addr_solicited_node(v6, &mac);
+		addr48_t mac;
+		addr48_solicited_node(v6, mac);
 
 		/* Avoid duplicate addresses in the list */
@@ -408,7 +407,5 @@
 
 		for (size_t j = 0; j < i; j++) {
-			eth_addr_t mac_entry;
-			eth_addr_decode(mac_list[j].address, &mac_entry);
-			if (eth_addr_compare(&mac_entry, &mac)) {
+			if (addr48_compare(mac_list[j].address, mac)) {
 				found = true;
 				break;
@@ -417,9 +414,8 @@
 
 		if (!found) {
-			eth_addr_encode(&mac, mac_list[i].address);
+			addr48(mac, mac_list[i].address);
 			i++;
-		} else {
+		} else
 			count--;
-		}
 	}
 
Index: uspace/srv/net/ethip/pdu.c
===================================================================
--- uspace/srv/net/ethip/pdu.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/ethip/pdu.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -60,6 +60,6 @@
 
 	hdr = (eth_header_t *)data;
-	eth_addr_encode(&frame->src, hdr->src);
-	eth_addr_encode(&frame->dest, hdr->dest);
+	addr48(frame->src, hdr->src);
+	addr48(frame->dest, hdr->dest);
 	hdr->etype_len = host2uint16_t_be(frame->etype_len);
 
@@ -93,6 +93,6 @@
 		return ENOMEM;
 
-	eth_addr_decode(hdr->src, &frame->src);
-	eth_addr_decode(hdr->dest, &frame->dest);
+	addr48(hdr->src, frame->src);
+	addr48(hdr->dest, frame->dest);
 	frame->etype_len = uint16_t_be2host(hdr->etype_len);
 
@@ -140,8 +140,8 @@
 	pfmt->proto_addr_size = IPV4_ADDR_SIZE;
 	pfmt->opcode = host2uint16_t_be(fopcode);
-	eth_addr_encode(&packet->sender_hw_addr, pfmt->sender_hw_addr);
+	addr48(packet->sender_hw_addr, pfmt->sender_hw_addr);
 	pfmt->sender_proto_addr =
 	    host2uint32_t_be(packet->sender_proto_addr);
-	eth_addr_encode(&packet->target_hw_addr, pfmt->target_hw_addr);
+	addr48(packet->target_hw_addr, pfmt->target_hw_addr);
 	pfmt->target_proto_addr =
 	    host2uint32_t_be(packet->target_proto_addr);
@@ -203,8 +203,8 @@
 	}
 
-	eth_addr_decode(pfmt->sender_hw_addr, &packet->sender_hw_addr);
+	addr48(pfmt->sender_hw_addr, packet->sender_hw_addr);
 	packet->sender_proto_addr =
 	    uint32_t_be2host(pfmt->sender_proto_addr);
-	eth_addr_decode(pfmt->target_hw_addr, &packet->target_hw_addr);
+	addr48(pfmt->target_hw_addr, packet->target_hw_addr);
 	packet->target_proto_addr =
 	    uint32_t_be2host(pfmt->target_proto_addr);
Index: uspace/srv/net/ethip/pdu.h
===================================================================
--- uspace/srv/net/ethip/pdu.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/ethip/pdu.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
Index: uspace/srv/net/ethip/std.h
===================================================================
--- uspace/srv/net/ethip/std.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/ethip/std.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -39,4 +39,5 @@
 
 #include <stdint.h>
+#include <inet/addr.h>
 
 #define ETH_ADDR_SIZE       6
@@ -47,7 +48,7 @@
 typedef struct {
 	/** Destination Address */
-	uint8_t dest[ETH_ADDR_SIZE];
+	addr48_t dest;
 	/** Source Address */
-	uint8_t src[ETH_ADDR_SIZE];
+	addr48_t src;
 	/** Ethertype or Length */
 	uint16_t etype_len;
@@ -67,11 +68,11 @@
 	uint16_t opcode;
 	/** Sender hardware address */
-	uint8_t sender_hw_addr[ETH_ADDR_SIZE];
+	addr48_t sender_hw_addr;
 	/** Sender protocol address */
-	uint32_t sender_proto_addr;
+	addr32_t sender_proto_addr;
 	/** Target hardware address */
-	uint8_t target_hw_addr[ETH_ADDR_SIZE];
+	addr48_t target_hw_addr;
 	/** Target protocol address */
-	uint32_t target_proto_addr;
+	addr32_t target_proto_addr;
 } __attribute__((packed)) arp_eth_packet_fmt_t;
 
Index: uspace/srv/net/inetsrv/addrobj.c
===================================================================
--- uspace/srv/net/inetsrv/addrobj.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/inetsrv/addrobj.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -38,5 +38,4 @@
 #include <errno.h>
 #include <fibril_synch.h>
-#include <inet/eth_addr.h>
 #include <io/log.h>
 #include <ipc/loc.h>
@@ -230,5 +229,5 @@
 
 	errno_t rc;
-	eth_addr_t ldest_mac;
+	addr48_t ldest_mac;
 
 	switch (ldest_ver) {
@@ -240,9 +239,9 @@
 		 * Translate local destination IPv6 address.
 		 */
-		rc = ndp_translate(lsrc_v6, ldest_v6, &ldest_mac, addr->ilink);
+		rc = ndp_translate(lsrc_v6, ldest_v6, ldest_mac, addr->ilink);
 		if (rc != EOK)
 			return rc;
 
-		return inet_link_send_dgram6(addr->ilink, &ldest_mac, dgram,
+		return inet_link_send_dgram6(addr->ilink, ldest_mac, dgram,
 		    proto, ttl, df);
 	default:
Index: uspace/srv/net/inetsrv/inet_link.c
===================================================================
--- uspace/srv/net/inetsrv/inet_link.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/inetsrv/inet_link.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -35,14 +35,13 @@
  */
 
+#include <stdbool.h>
 #include <errno.h>
+#include <str_error.h>
 #include <fibril_synch.h>
-#include <inet/eth_addr.h>
 #include <inet/iplink.h>
 #include <io/log.h>
 #include <loc.h>
-#include <stdbool.h>
 #include <stdlib.h>
 #include <str.h>
-#include <str_error.h>
 #include "addrobj.h"
 #include "inetsrv.h"
@@ -57,5 +56,5 @@
 
 static errno_t inet_iplink_recv(iplink_t *, iplink_recv_sdu_t *, ip_ver_t);
-static errno_t inet_iplink_change_addr(iplink_t *, eth_addr_t *);
+static errno_t inet_iplink_change_addr(iplink_t *, addr48_t);
 static inet_link_t *inet_link_get_by_id_locked(sysarg_t);
 
@@ -71,18 +70,15 @@
     { 0xfe, 0x80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0xff, 0xfe, 0, 0, 0 };
 
-static void inet_link_local_node_ip(eth_addr_t *mac_addr,
+static void inet_link_local_node_ip(addr48_t mac_addr,
     addr128_t ip_addr)
 {
-	uint8_t b[ETH_ADDR_SIZE];
-
 	memcpy(ip_addr, link_local_node_ip, 16);
-	eth_addr_encode(mac_addr, b);
-
-	ip_addr[8] = b[0] ^ 0x02;
-	ip_addr[9] = b[1];
-	ip_addr[10] = b[2];
-	ip_addr[13] = b[3];
-	ip_addr[14] = b[4];
-	ip_addr[15] = b[5];
+
+	ip_addr[8] = mac_addr[0] ^ 0x02;
+	ip_addr[9] = mac_addr[1];
+	ip_addr[10] = mac_addr[2];
+	ip_addr[13] = mac_addr[3];
+	ip_addr[14] = mac_addr[4];
+	ip_addr[15] = mac_addr[5];
 }
 
@@ -125,15 +121,13 @@
 }
 
-static errno_t inet_iplink_change_addr(iplink_t *iplink, eth_addr_t *mac)
-{
-	eth_addr_str_t saddr;
-
-	eth_addr_format(mac, &saddr);
+static errno_t inet_iplink_change_addr(iplink_t *iplink, addr48_t mac)
+{
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "inet_iplink_change_addr(): "
-	    "new addr=%s", saddr.str);
+	    "new addr=%02x:%02x:%02x:%02x:%02x:%02x",
+	    mac[0], mac[1], mac[2], mac[3], mac[4], mac[5]);
 
 	list_foreach(inet_links, link_list, inet_link_t, ilink) {
 		if (ilink->sess == iplink->sess)
-			ilink->mac = *mac;
+			memcpy(&ilink->mac, mac, sizeof(addr48_t));
 	}
 
@@ -267,5 +261,5 @@
 
 		addr128_t link_local;
-		inet_link_local_node_ip(&ilink->mac, link_local);
+		inet_link_local_node_ip(ilink->mac, link_local);
 
 		inet_naddr_set6(link_local, 64, &addr6->naddr);
@@ -393,5 +387,5 @@
  *
  */
-errno_t inet_link_send_dgram6(inet_link_t *ilink, eth_addr_t *ldest,
+errno_t inet_link_send_dgram6(inet_link_t *ilink, addr48_t ldest,
     inet_dgram_t *dgram, uint8_t proto, uint8_t ttl, int df)
 {
@@ -407,5 +401,5 @@
 
 	iplink_sdu6_t sdu6;
-	sdu6.dest = *ldest;
+	addr48(ldest, sdu6.dest);
 
 	/*
